# coding: utf-8

"""
    Equinix Fabric API v4

    Equinix Fabric is an advanced software-defined interconnection solution that enables you to directly, securely and dynamically connect to distributed infrastructure and digital ecosystems on platform Equinix via a single port, Customers can use Fabric to connect to: </br> 1. Cloud Service Providers - Clouds, network and other service providers.  </br> 2. Enterprises - Other Equinix customers, vendors and partners.  </br> 3. Myself - Another customer instance deployed at Equinix. </br> </br> <b>Integrations (SDKs, Tools) links:</b> </br> <a href=\"https://deploy.equinix.com/labs/fabric-java\\\">Fabric Java SDK</a> </br> <a href=\"https://deploy.equinix.com/labs/equinix-sdk-go\\\">Fabric Go SDK</a> </br> <a href=\"https://deploy.equinix.com/labs/equinix-sdk-python\\\">Fabric Python SDK</a> </br> <a href=\"https://deploy.equinix.com/labs/terraform-provider-equinix\\\">Equinix Terraform Provider</a> </br> <a href=\"https://deploy.equinix.com/labs/terraform-equinix-fabric\\\">Fabric Terraform Modules</a> </br> <a href=\"https://deploy.equinix.com/labs/pulumi-provider-equinix/\">Equinix Pulumi Provider</a> </br>

    The version of the OpenAPI document: 4.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from equinix.services.fabricv4.models.package_response import PackageResponse

class TestPackageResponse(unittest.TestCase):
    """PackageResponse unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> PackageResponse:
        """Test PackageResponse
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `PackageResponse`
        """
        model = PackageResponse()
        if include_optional:
            return PackageResponse(
                pagination = equinix.services.fabricv4.models.pagination.Pagination(
                    offset = 0, 
                    limit = 0, 
                    total = 0, 
                    next = '', 
                    previous = '', ),
                data = [
                    equinix.services.fabricv4.models.cloud_router_package.CloudRouterPackage(
                        href = 'https://api.equinix.com/fabric/v4/routerPackages/LAB', 
                        type = 'ROUTER_PACKAGE', 
                        code = 'LAB', 
                        description = '', 
                        total_ipv4_routes_max = 50, 
                        total_ipv6_routes_max = 50, 
                        static_ipv4_routes_max = 3, 
                        static_ipv6_routes_max = 0, 
                        nacls_max = 2, 
                        nacl_rules_max = 5, 
                        ha_supported = True, 
                        route_filter_supported = True, 
                        nat_type = 'STATIC_NAT', 
                        vc_count_max = 10, 
                        cr_count_max = 3, 
                        vc_bandwidth_max = 50, 
                        change_log = equinix.services.fabricv4.models.package_change_log.PackageChangeLog(
                            created_date_time = '2020-11-06T07:00Z', 
                            updated_date_time = '2020-11-06T07:00Z', ), )
                    ]
            )
        else:
            return PackageResponse(
        )
        """

    def testPackageResponse(self):
        """Test PackageResponse"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
